package io.tswf.transmutations.common.conflict

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.annotation.OnConflict
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class ConflictStrategyReader {

    public static final String VALUE_PARAMETER_NAME = "value"

    static ConflictingMethodResolveStrategy readConflictStrategy(MethodNode methodNode, ConflictingMethodResolveStrategy defaultValue = ConflictingMethodResolveStrategy.THROW) {
        def onConflictAnnotation = methodNode.findAnnotationByType(OnConflict)
        if (onConflictAnnotation != null) {
            return onConflictAnnotation.getValueByName(VALUE_PARAMETER_NAME, ConflictingMethodResolveStrategy)
        }

        return defaultValue
    }
}
