package io.tswf.transmutations.common.exception

import groovy.transform.CompileStatic
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class ConflictingMethodFoundException extends RuntimeException {
    ClassNode targetClass
    MethodNode conflictingMethod
    ClassNode anotherMethodOwner
    MethodNode anotherMethod

    ConflictingMethodFoundException(ClassNode targetClass, MethodNode conflictingMethod, ClassNode anotherMethodOwner, MethodNode anotherMethod) {
        super("The method ${conflictingMethod.javaFullName} is already exist in ${targetClass.javaName}! Conflict with ${anotherMethod.javaFullName} located in ${anotherMethodOwner.javaName}!")
        this.targetClass = targetClass
        this.conflictingMethod = conflictingMethod
        this.anotherMethodOwner = anotherMethodOwner
        this.anotherMethod = anotherMethod
    }
}
